import React from 'react';
import { scaleLinear, scaleSequential, scaleOrdinal, extent } from 'd3';
import { MapMarks } from './Marks';
import { ColorBarMark } from './ColorBarMark';

export const MapColorMark = ({
  data,
  atlas,
  avgValue,
  colorValue,
  innerWidth,
  innerHeight,
  tooltipValue,
  setSelectedValue,
  selectedValue,
  setHoveredValue,
  hoveredValue,
  hoverOpacity,
  fadeOpacity
}) => {
  const legendOffsetX = innerWidth * 2 + 50;
  const legendOffsetY = innerHeight;

  console.log('Calling MapColorMark...');
  console.log(extent(data, avgValue));
  console.log(tooltipValue);
  
  const mapColorScale = scaleLinear()
    .domain(extent(data, avgValue))
    .range(['white', 'blue']);
  
  const mapColorScale2 = scaleSequential()
    .domain([0, 60])
    .interpolator(d3.interpolatePuRd);
  //   	.interpolator(d3.interpolateViridis); //interpolatePuRd
  //  console.log(mapColorScale(avgValue));

  return (
    <>
      <MapMarks
        data={data}
        atlas={atlas}
        colorValue={avgValue}
        colorScale={mapColorScale}
        tooltipValue={tooltipValue}
        onClick={setSelectedValue}
        selectedValue={selectedValue}
        onHover={setHoveredValue}
        hoveredValue={hoveredValue}
        hoverOpacity={hoverOpacity}
        fadeOpacity={fadeOpacity}
      />
      <g transform={`translate(${legendOffsetX}, ${legendOffsetY})`}>
        <ColorBarMark
          data={data}
          colorValue={avgValue}
          colorScale={mapColorScale}
        />
      </g>
    </>
  );
};
